package com.link.core.parserplugin.parser;

import com.link.core.parserplugin.AbstractScriptParser;
import com.link.core.parserplugin.util.ParserUtil;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.ibatis.ognl.Ognl;
import org.apache.ibatis.ognl.OgnlContext;

public class OgnlParser extends AbstractScriptParser {
   private final ConcurrentHashMap<String, Object> EXPRESSION_CACHE = new ConcurrentHashMap();
   private final ConcurrentHashMap<String, Class<?>> funcs = new ConcurrentHashMap(8);

   public void addFunction(String name, Method method) {
      this.funcs.put(name, method.getDeclaringClass());
   }

   public <T> T getElValue(String exp, Object target, Object[] arguments, Object retVal, boolean hasRetVal, Object userVal, boolean hasUserVal, Class<T> valueType) throws Exception {
      if (valueType.equals(String.class) && exp.indexOf("#") == -1 && exp.indexOf("@") == -1 && exp.indexOf("'") == -1) {
         return exp;
      } else {
         Object object = this.EXPRESSION_CACHE.get(exp);
         if (null == object) {
            String className = ParserUtil.class.getName();
            String exp2 = exp.replaceAll("@@hash\\(", "@" + className + "@getUniqueHashStr(");
            exp2 = exp2.replaceAll("@@empty\\(", "@" + className + "@isEmpty(");

            Map.Entry entry;
            for(Iterator<Map.Entry<String, Class<?>>> it = this.funcs.entrySet().iterator(); it.hasNext(); exp2 = exp2.replaceAll("@@" + (String)entry.getKey() + "\\(", "@" + className + "@" + (String)entry.getKey() + "(")) {
               entry = (Map.Entry)it.next();
               className = ((Class)entry.getValue()).getName();
            }

            object = Ognl.parseExpression(exp2);
            this.EXPRESSION_CACHE.put(exp, object);
         }

         Map<String, Object> values = new HashMap(2);
         values.put("target", target);
         values.put("args", arguments);
         if (hasUserVal) {
            values.put("userVal", userVal);
         }

         if (hasRetVal) {
            values.put("retVal", retVal);
         }

         OgnlContext context = new OgnlContext(values);
         context.setRoot(arguments);
         Object res = Ognl.getValue(object, context, context.getRoot(), valueType);
         return res;
      }
   }
}
